//THREAD CHE GESTISCE LA CONNESSIONE ESTERNA NEL ServerParallelo 

import java.net.*;
import java.io.*;

public class ConnessioneEsterna implements Runnable{
	
	//Connessione esterna con il WAP Server
	Socket WAPsocket;
	
	//Indirizzo IP Server remoto per la connessione interna
	String hostRemoto;
	
	//Porta del Server remoto
	int PortaServerRemoto;
	
	//Costruttore
	public ConnessioneEsterna(Socket sock,String hostRem,int porta){
		WAPsocket = sock;
		hostRemoto = hostRem;
		PortaServerRemoto=porta;
	}
	
	public void run(){
		try{
			
				//Stream di ingresso dal Server WAP
					DataInputStream inStreamWAP = new DataInputStream(WAPsocket.getInputStream());
					byte request[] = new byte[10];
					
			/*Ritardo per lettura completa,
				modificare con lettura di singoli caratteri
			*/	
				try{
			//			System.out.println("Ritardo di 1 secondo per aspettare la lettura");
						Thread.sleep(500);
				 	}catch(InterruptedException e){}	
						
					int byteLetti = inStreamWAP.read(request);
					String richiesta = new String(request);
					System.out.println("Ricevuto dal Server WAP : '"+richiesta+"' letti "+byteLetti+" byte");
					
					//Estrazione operazione e nome del file
					String op = richiesta.substring(0,1);//.charAt(0);
					String nomeFile = richiesta.substring(2,10);								
								
					//CONNESSIONE all'altro SERVER per la connessione interna
										
				  //Indirizzo IP del Server remoto
				  InetAddress remoteHost = InetAddress.getByName(hostRemoto);
				  
				  //Connessione al Server remoto	
				  Socket serverRemoto = new Socket(remoteHost,PortaServerRemoto);
				  
				 	//Stream di uscita per il Server remoto
					DataOutputStream outStreamServerRemoto = new DataOutputStream(serverRemoto.getOutputStream());
					outStreamServerRemoto.writeBytes(richiesta);
					outStreamServerRemoto.flush();
					System.out.println("Spedito al Server Secondario : '"+richiesta+"'");
					System.out.println(" ...");
					System.out.println("  attesa risposta dal Server Secondario ");
					System.out.println("                                      ...");
					//Stream di ingresso dal Server remoto
					DataInputStream inStreamServerRemoto = new DataInputStream(serverRemoto.getInputStream());
					boolean risultatoOperazione = inStreamServerRemoto.readBoolean();
					System.out.println("Esito ricevuto dal Server Secodario '"+risultatoOperazione+"'");
					boolean esito = risultatoOperazione;
          if(risultatoOperazione){
          	Operazione operazione = new Operazione();
          	esito = operazione.op(nomeFile,op);
          	System.out.println("Esito operazione sul Server Principale '"+esito+"'");	
          }
					serverRemoto.close();
					
				//Stream di uscita per il Server WAP
					DataOutputStream outStreamWAP = new DataOutputStream(WAPsocket.getOutputStream());
					outStreamWAP.writeBoolean(esito);
					System.out.println("Esito spedito al Server WAP '"+esito+"'");
															
				//Se l'esito dell'operazione sul Server Principale fallisce 
				//disfare l'operazione sul Server Seconadrio
					if(!esito&&risultatoOperazione){
						String richiestaDisfare;
						if(op.equals("+")){op="-";}
					  	else op="+";
						try{
							//Attesa di 5 secondi per testare la connessione	
							try{
								System.out.println("Ritardo di 5 secondi per simulare la caduta del Server Secondario");
								Thread.sleep(5000);
					  	}catch(InterruptedException e){}
							
					  	serverRemoto = new Socket(remoteHost,PortaServerRemoto);
					  	
					 		//Stream di uscita per il Server remoto
							outStreamServerRemoto = new DataOutputStream(serverRemoto.getOutputStream());
							richiestaDisfare =op+" "+nomeFile; 
							outStreamServerRemoto.writeBytes(richiestaDisfare);
							outStreamServerRemoto.flush();
							System.out.println("Attivato PROTOCOLLO di RECOVERY");
							System.out.println("Spedito '"+richiestaDisfare+"' al Server Secondario per disfare l'operazione");
					  
					  //	serverRemoto.close();	
							
						}catch(IOException sex){
							System.out.println("           CRASH del Server Secondario ");
							System.out.println("INCONSISTENZA TRA I DUE SERVER ");
							System.out.println("Operazione non disfatta sul Server Secondario");
							
							/*
								PROTOCOLLO DI RECOVERY
								Ciclo in attesa che venga ripristinato il Server Secondario
								che  in CRASH, e prova a rieseguire l'operazione. 
							*/
							boolean recovery = true;
							while(recovery){
								try{
									//Tentativo di connessione con il Server Secondario
										serverRemoto = new Socket(remoteHost,PortaServerRemoto);

									//Stream di uscita per il Server remoto
										outStreamServerRemoto = new DataOutputStream(serverRemoto.getOutputStream());
										richiestaDisfare =op+" "+nomeFile; 
										outStreamServerRemoto.writeBytes(richiestaDisfare);
										outStreamServerRemoto.flush();
										System.out.println("Server Secondario riavviato, attivato PROTOCOLLO di RECOVERY");
										recovery = false;
								}catch(IOException sex_1){}
							}	
						 }finally{serverRemoto.close();}
					}
			
			
			//Chiusura della connessione esterna con il WAP Server	
			WAPsocket.close();
				   	  
		}catch(IOException ex){
			System.out.println("          CRASH del Server Secondario ");
			try{
			//Stream di uscita per il Server WAP
			DataOutputStream outStreamWAP = new DataOutputStream(WAPsocket.getOutputStream());
			outStreamWAP.writeBoolean(false);
			System.out.println("Esito spedito al Server WAP false");
			//Chiusura della connessione esterna con il WAP Server	
			WAPsocket.close();
			}catch(IOException w){}

		 }
	}
	
}