//Gestione della comunicazione interna con l'altro Server

import java.net.*;
import java.io.*;

public class ServerParalleloThread implements Runnable{
	//Porta su cui accettare la connessione dell'altro Server
		int Porta;
		
				
	//Costruttore
	public ServerParalleloThread(int port){
	 Porta = port;
	}
	
	public void run(){
		try{	
			//Crezione della socket per la cooperazione interna con l'altro Server 
			ServerSocket serverThread = new ServerSocket(Porta);
			InetAddress host = InetAddress.getLocalHost();
   	  System.out.println("Connessione interna sulla porta :"+serverThread.getLocalPort());
   	  
   	  	while(true){
   	  		//ServerThread si mette in attesa di connessione dell'altro Server
					Socket server = serverThread.accept();
					String destName = server.getInetAddress().getHostName();
					int destPort = server.getPort();
					System.out.println("--------------- SERVER SECONDARIO ------------------");
					System.out.println("Accettata connessione dal Server Principale '"+destName+"' sulla porta '"+Porta+"'");
					
					//Generazione del thread che gestisce la comunicazione interna
					ConnessioneInterna gestioneConnessioneInterna = new ConnessioneInterna(server);
					Thread gCI = new Thread(gestioneConnessioneInterna);
					gCI.start();

			}

   	  
		}catch(SocketException sex){
			System.out.println("Errore di connessione "+sex.getMessage());
		 }
		 catch(IOException ioex){
		 	System.out.println("Errore "+ioex.getMessage());
		 }
	}
	
}