import java.net.*;
import java.io.*;

public class ServerParallelo{
	public static void main(String args[]){
	 try{	
	 	
	 	//Indirizzo IP dell'altro Server per la connessione interna
	 	String hostRemoto = args[0];	 	
	 	
		//Porte su cui avviene la comunicazione 
		int portaServer =1234; 
		int portaServerThread =1235; 
		
		//Generazione del thread che gestisce la cooperazione interna con l'altro Server
		ServerParalleloThread serverThread = new ServerParalleloThread(portaServerThread);
		Thread ST = new Thread(serverThread);
		ST.start();
		
		//Creazione della socket per la connessione esterna
		ServerSocket serverPrincipale = new ServerSocket(portaServer);
		InetAddress host = InetAddress.getLocalHost();
    System.out.println("Indirizzo IP del Server : "+host.getHostAddress());
    System.out.println("Connessione esterna sulla porta :"+serverPrincipale.getLocalPort());
    		
		while(true){
   	  		//ServerPrinciple si mette in attesa di connessione del WAP Server
					Socket serverWAP = serverPrincipale.accept();
					String destName = serverWAP.getInetAddress().getHostName();
					int destPort = serverWAP.getPort();
					System.out.println("--------------- SERVER PRINCIPALE ------------------");
					System.out.println("Accettata connessione esterna dal Server WAP '"+destName+"' sulla porta '"+portaServer+"'");
							
					//Generazione del thread per gestire la connessione con il WAP Server
					ConnessioneEsterna gestioneConnessioneWAP = new ConnessioneEsterna(serverWAP,hostRemoto,portaServerThread);
					Thread gCWAP = new Thread(gestioneConnessioneWAP);
					gCWAP.start();
				
			}
	 }catch(SocketException sex){
	 		System.out.println("Errore di connessione  "+sex.getMessage());
	 	}
	 catch(IOException ioex){
	 		System.out.println("Errore "+ioex.getMessage());
	 	}	
	}
}